
Auto Multiple Choice - Bug # 679: AMC (git:b8e377a2) problème d'impression sous macOS 10.15.1

Status: Closed Priority: Normal
Author: Joël Brogniart Category:
Created: 11/08/2019 Assignee:
Updated: 02/07/2021 Due date:
Description: J'ai installé la dernière version d'AMC (git:b8e377a2) sous macOS 10.15 et j'ai un problème d'impression. Je 

n'ai pas les outils sous la main pour tester une version plus ancienne ou une autre version de macOS donc je 
ne sais pas si le problème provient de ma configuration ou de la version d'AMC.

Lorsque je lance l'impression d'un sujet, l'impression a l'air de bien fonctionner mais rien ne sort sur 
l'imprimante. Lorsque je regarde le journal du mode debug (joint), je vois les commandes utilisées pour 
générer le pdf et pour imprimer. Dans le journal, il semble que les chemins d'accès des fichiers ne sont pas 
quotés et comme il y a des espaces ou des caractères accentués il y a de fortes chances qu'une des 
commande échoue (je pense principalement aux arguments de la commande @qpdf@).

Si je lance la commande telle quelle dans mon terminal; elle échoue mais si je quote les chemins de fichiers 
dans les arguments, le fichier est bien créé et j'arrive bien à imprimer ce fichier en utilisant la commande @lp@ 
qui suit.

History
11/15/2019 10:59 am - Joël Brogniart
- File AMC-DEBUG-N1bJi5mO.log added

Bon, j'ai eu le temps de fouiller un peu et de faire quelques tests. J'ai regardé le code et apparemment ce n'est pas l'histoire des guillemets parce que 
ce côté là n'a pas changé depuis la version 1.4.0. Donc je pense que le problème est dans la partie du code 
@auto-multiple-choice/AMC-perl/AMC/Print@. J'ai donc essayé d'imprimer un sujet à partir de plusieurs version d'AMC en suivant les commits, 
toujours avec les versions macOS 10.15.1 (MacPorts 2.6.2, Xcode 11.2.1).

git:c6041a16 (1.4.0), l'impression fonctionne.

git:43a83e09, l'impression fonctionne.

git:2005b218, l'impression fonctionne.

git:4227f0e4, l'impression ne fonctionne plus.

Lorsque l'impression fonctionne, le détail de la sortie des commandes contient deux lignes :
<pre>
Student 0005 : 1 slices to file /var/folders/x2/06wgm6dw8xl9rb008k8d_w480000gp/T/0Ka2lap9aK.pdf...
Request id is The_choosen_printer (1 file(s))
</pre>

Lorsque l'impression ne fonctionne pas, la deuxième ligne n'est pas affichée.

Je mets le journal pour l'impression à partir de la version git:4227f0e4 et je vais voir si je comprends quelque chose dans les changements apportés 
pour ce commit.

11/15/2019 12:34 pm - Joël Brogniart
Dans le doute, j'ai aussi testé l'impression avec git:391018ba et là ça fonctionne. Donc le problème est bien lié aux changements dans git:4227f0e4.
11/15/2019 12:57 pm - Joël Brogniart
Le problème est lié au changement dans le fichier @AMC-perl/AMC/Print/cupslp.pm@ ou
<pre>
system(@command);
</pre>

est remplacé par
<pre>
system_stderr( cmd => [@command] );
</pre>

La fonction @system_stderr@ n'est pas trouvée (c'est bien ce qui est indiqué dans le journal). Si je remplace @system_stderr@ par @system@ les 
impressions fonctionnent à nouveau.

11/15/2019 01:09 pm - Joël Brogniart
Et au même endroit, si je remplace

<pre>
system_stderr( cmd => [@command] );
</pre>

par 
<pre>
system_debug( cmd => [@command] );
</pre>

(@system_debug @ est la fonction qui est utilisée dans les autres fichiers à la place de @system@) l'impression fonctionne aussi. 

11/16/2019 10:26 pm - Alexis Bienvenüe
- Status changed from New to Resolved

- % Done changed from 0 to 100

Merci pour cette analyse et le correctif ! Intégré avec git:c794ec55

02/07/2021 03:04 pm - Alexis Bienvenüe
- Status changed from Resolved to Closed

Files
AMC-DEBUG-nQVUlvPQ.log 16.2 kB 11/08/2019 Joël Brogniart
AMC-DEBUG-N1bJi5mO.log 14.5 kB 11/15/2019 Joël Brogniart
